# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xcluster`](#dsc_xcluster): The DSC xCluster resource type. Automatically generated from version 1.10.0.0
* [`dsc_xclusterdisk`](#dsc_xclusterdisk): The DSC xClusterDisk resource type. Automatically generated from version 1.10.0.0
* [`dsc_xclusternetwork`](#dsc_xclusternetwork): The DSC xClusterNetwork resource type. Automatically generated from version 1.10.0.0
* [`dsc_xclusterpreferredowner`](#dsc_xclusterpreferredowner): The DSC xClusterPreferredOwner resource type. Automatically generated from version 1.10.0.0
* [`dsc_xclusterproperty`](#dsc_xclusterproperty): The DSC xClusterProperty resource type. Automatically generated from version 1.10.0.0
* [`dsc_xclusterquorum`](#dsc_xclusterquorum): The DSC xClusterQuorum resource type. Automatically generated from version 1.10.0.0
* [`dsc_xwaitforcluster`](#dsc_xwaitforcluster): The DSC xWaitForCluster resource type. Automatically generated from version 1.10.0.0

## Resource types

### `dsc_xcluster`

The DSC xCluster resource type.
Automatically generated from version 1.10.0.0

#### Properties

The following properties are available in the `dsc_xcluster` type.

##### `dsc_ignorenetwork`

Data type: `Optional[Array[String]]`

One or more networks to ignore when creating the cluster. Only networks using Static IP can be ignored, networks that are assigned an IP address through DHCP cannot be ignored, and are added for cluster communication. To remove networks assigned an IP address through DHCP use the resource xClusterNetwork to change the role of the network. This parameter is only used during the creation of the cluster and is not monitored after.

##### `dsc_staticipaddress`

Data type: `Optional[String]`

StaticIPAddress of the Cluster

#### Parameters

The following parameters are available in the `dsc_xcluster` type.

##### `dsc_domainadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to create the cluster

##### `dsc_name`

namevar

Data type: `String`

Name of the Cluster

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xclusterdisk`

The DSC xClusterDisk resource type.
Automatically generated from version 1.10.0.0

#### Properties

The following properties are available in the `dsc_xclusterdisk` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Define if the cluster disk should be added (Present) or removed (Absent). Default value is 'Present'.

##### `dsc_label`

Data type: `Optional[String]`

The disk label that should be assigned to the disk on the Failover Cluster disk resource.

#### Parameters

The following parameters are available in the `dsc_xclusterdisk` type.

##### `dsc_number`

namevar

Data type: `String`

The disk number of the cluster disk.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xclusternetwork`

The DSC xClusterNetwork resource type.
Automatically generated from version 1.10.0.0

#### Properties

The following properties are available in the `dsc_xclusternetwork` type.

##### `dsc_metric`

Data type: `Optional[String]`

The metric number for the cluster network. If the cluster network metric number is not in desired state it will be changed to match this metric number.

##### `dsc_name`

Data type: `Optional[String]`

The name of the cluster network. If the cluster network name is not in desired state it will be renamed to match this name.

##### `dsc_role`

Data type: `Optional[Enum['0', '1', '3']]`

he role of the cluster network. If the cluster network role is not in desired state it will change to match this role.

#### Parameters

The following parameters are available in the `dsc_xclusternetwork` type.

##### `dsc_address`

namevar

Data type: `String`

The address for the cluster network in the format '10.0.0.0'.

##### `dsc_addressmask`

namevar

Data type: `String`

The address mask for the cluster network in the format '255.255.255.0'.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xclusterpreferredowner`

The DSC xClusterPreferredOwner resource type.
Automatically generated from version 1.10.0.0

#### Properties

The following properties are available in the `dsc_xclusterpreferredowner` type.

##### `dsc_clusterresources`

Data type: `Optional[Array[String]]`

he resources to set preferred owners on.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

If the preferred owners should be present or absent. Default value is 'Present'.

##### `dsc_nodes`

Data type: `Array[String]`

The nodes to set as owners.

#### Parameters

The following parameters are available in the `dsc_xclusterpreferredowner` type.

##### `dsc_clustergroup`

namevar

Data type: `String`

Name of the cluster group.

##### `dsc_clustername`

namevar

Data type: `String`

Name of the cluster.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xclusterproperty`

The DSC xClusterProperty resource type.
Automatically generated from version 1.10.0.0

#### Properties

The following properties are available in the `dsc_xclusterproperty` type.

##### `dsc_addevictdelay`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies how many seconds after a node is evicted that the failover cluster service will wait before adding a new node.

##### `dsc_clusterloglevel`

Data type: `Optional[Integer[0, 4294967295]]`

Controls the level of cluster logging.

##### `dsc_clusterlogsize`

Data type: `Optional[Integer[0, 4294967295]]`

Controls the maximum size of the cluster log files on each of the nodes.

##### `dsc_crosssitedelay`

Data type: `Optional[Integer[0, 4294967295]]`

Controls the time interval, in milliseconds, that the cluster network driver waits between sending Cluster Service heartbeats across sites.

##### `dsc_crosssitethreshold`

Data type: `Optional[Integer[0, 4294967295]]`

Controls how many Cluster Service heartbeats can be missed across sites before it determines that Cluster Service has stopped responding.

##### `dsc_crosssubnetdelay`

Data type: `Optional[Integer[0, 4294967295]]`

Controls the time interval, in milliseconds, that the cluster network driver waits between sending Cluster Service heartbeats across subnets.

##### `dsc_crosssubnetthreshold`

Data type: `Optional[Integer[0, 4294967295]]`

Controls how many Cluster Service heartbeats can be missed across subnets before it determines that Cluster Service has stopped responding.

##### `dsc_databasereadwritemode`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the read/write mode for the cluster database.

##### `dsc_defaultnetworkrole`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the role that the cluster automatically assigns to any newly discovered or created network.

##### `dsc_description`

Data type: `Optional[String]`

Stores administrative comments about the cluster. The following table summarizes the attributes of the Description property.

##### `dsc_drainonshutdown`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies whether to enable Node Drain for a cluster.

##### `dsc_dynamicquorum`

Data type: `Optional[Integer[0, 4294967295]]`

Enables the cluster to change the required number of nodes that need to participate in quorum when nodes shut down or crash.

##### `dsc_netftipsecenabled`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies whether Internet Protocol Security (IPSec) encryption is enabled for inter-node cluster communication.

##### `dsc_preferredsite`

Data type: `Optional[String]`

Specifies the preferred site for a site-aware cluster.

##### `dsc_quarantineduration`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the quarantine duration for a node, in seconds.

##### `dsc_quarantinethreshold`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the quarantine threshold for a node, in minutes.

##### `dsc_samesubnetdelay`

Data type: `Optional[Integer[0, 4294967295]]`

Controls the delay, in milliseconds, between netft heartbeats.

##### `dsc_samesubnetthreshold`

Data type: `Optional[Integer[0, 4294967295]]`

Controls how many heartbeats can be missed on the same subnet before the route is declared as unreachable.

##### `dsc_shutdowntimeoutinminutes`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies how many minutes after a system shutdown is initiated that the failover cluster service will wait for resources to go offline.

#### Parameters

The following parameters are available in the `dsc_xclusterproperty` type.

##### `dsc_name`

namevar

Data type: `String`

Name of the cluster.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xclusterquorum`

The DSC xClusterQuorum resource type.
Automatically generated from version 1.10.0.0

#### Properties

The following properties are available in the `dsc_xclusterquorum` type.

##### `dsc_resource`

Data type: `Optional[String]`

The name of the disk, file share or Azure storage account resource to use as witness. This parameter is optional if the quorum type is set to NodeMajority.

##### `dsc_storageaccountaccesskey`

Data type: `Optional[String]`

The access key of the Azure storage account to use as witness. This parameter is required if the quorum type is set to NodeAndCloudMajority. The key is currently not updated if the resource is already set.

##### `dsc_type`

Data type: `Optional[Enum['NodeMajority', 'NodeAndDiskMajority', 'NodeAndFileShareMajority', 'NodeAndCloudMajority', 'DiskOnly']]`

Quorum type to use. Can be set to either NodeMajority, NodeAndDiskMajority, NodeAndFileShareMajority, NodeAndCloudMajority or DiskOnly.

#### Parameters

The following parameters are available in the `dsc_xclusterquorum` type.

##### `dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xwaitforcluster`

The DSC xWaitForCluster resource type.
Automatically generated from version 1.10.0.0

#### Properties

The following properties are available in the `dsc_xwaitforcluster` type.

##### `dsc_retrycount`

Data type: `Optional[Integer[0, 4294967295]]`

Maximum number of retries to check for cluster existence. Default value is 50 retries.

##### `dsc_retryintervalsec`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Interval to check for cluster existence. Default values is 10 seconds.

#### Parameters

The following parameters are available in the `dsc_xwaitforcluster` type.

##### `dsc_name`

namevar

Data type: `String`

Name of the cluster to wait for.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

