require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xclusternetwork',
  dscmeta_resource_friendly_name: 'xClusterNetwork',
  dscmeta_resource_name: 'MSFT_xClusterNetwork',
  dscmeta_module_name: 'xFailOverCluster',
  dscmeta_module_version: '1.10.0.0',
  docs: 'The DSC xClusterNetwork resource type.
         Automatically generated from version 1.10.0.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_addressmask: {
      type: 'String',
      desc: "The address mask for the cluster network in the format '255.255.255.0'.",
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_metric: {
      type: 'Optional[String]',
      desc: 'The metric number for the cluster network. If the cluster network metric number is not in desired state it will be changed to match this metric number.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_role: {
      type: "Optional[Enum['0', '1', '3']]",
      desc: 'he role of the cluster network. If the cluster network role is not in desired state it will change to match this role.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_name: {
      type: 'Optional[String]',
      desc: 'The name of the cluster network. If the cluster network name is not in desired state it will be renamed to match this name.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_address: {
      type: 'String',
      desc: "The address for the cluster network in the format '10.0.0.0'.",
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
